-- name: SM64 \\#0f52ba\\Sapphire\\#ffffff\\ v1.1
-- description: This is a short 30 star rom hack known as SM64 Sapphire, made by Nebula.\n\nPorted to PC by aspieweeb759/sarah_taylor\n\nPorted to coop by \\#50c7c7\\Chilly Blues\\#ffffff\\\n\n updated by \\#2d851c\\Mr.Needlemouse\\#ffffff\\
-- incompatible: romhack

------------------
-- level values --
------------------

gLevelValues.fixCollisionBugs = 1
gLevelValues.entryLevel = LEVEL_CASTLE
gLevelValues.exitCastleLevel = LEVEL_CASTLE
gLevelValues.exitCastleWarpNode = 0x40

gServerSettings.skipIntro = 1


------------------
-- behavior values --
------------------
gBehaviorValues.ToadStar2Requirement = 0

--------------
-- movtexs --
--------------

movtexqc_register('bob_1_Movtex_0',               5 + 4, 1, 0)
movtexqc_register('jrb_1_Movtex_0',               8 + 4, 1, 0)
movtexqc_register('bits_1_Movtex_0',               17 + 4, 1, 0)

-----------
-- music --
-----------

smlua_audio_utils_replace_sequence(0x03, 0x25, 80, "25_Seq_sapphire_custom")
smlua_audio_utils_replace_sequence(0x06, 0x11, 80, "24_Seq_sapphire_custom")
smlua_audio_utils_replace_sequence(0x08, 0x0B, 80, "23_Seq_sapphire_custom")
smlua_audio_utils_replace_sequence(0x0C, 0x25, 80, "28_Seq_sapphire_custom")

------------
-- camera --
------------
camera_set_use_course_specific_settings(false)

----------------------------------

--Warps to the correct place after the end screen
function wrong_warp()
    if gNetworkPlayers[0].currLevelNum == LEVEL_CASTLE_GROUNDS then
        warp_to_level(LEVEL_CASTLE, 1, 0)
    end
end

------------------
--100% Reward :)--
------------------
ShowReward = true
for i in pairs(gActiveMods) do
    if (gActiveMods[i].incompatible ~= nil and gActiveMods[i].incompatible:find("gamemode")) and not (gActiveMods[i].name:find("Personal Star Counter EX+")) then
        ShowReward = false
    end
end

function true_ending_reward(m)
    if m.numStars >= 30 and ShowReward then
        if not gNetworkPlayers[m.playerIndex].connected then return end
        if gNetworkPlayers[m.playerIndex].currLevelNum ~= gNetworkPlayers[0].currLevelNum or gNetworkPlayers[m.playerIndex].currAreaIndex ~= gNetworkPlayers[0].currAreaIndex then return end
        m.particleFlags = m.particleFlags | PARTICLE_SPARKLES
    end
end




------------------
--Star positions--
------------------

    starPositions = gLevelValues.starPositions

    vec3f_set(starPositions.ChillBullyStarPos,      -5672.0,  2128.0, 2900.0)
    vec3f_set(starPositions.BigPiranhasStarPos,   -398.0, 1112.0, -2646.0)
    vec3f_set(starPositions.TuxieMotherStarPos,    -451.0, 2619.0,  331.0)
    vec3f_set(starPositions.BigBullyTrioStarPos,       3962.0,   547.0, -5576.0)


---------------------
--Custom Grand Star--
---------------------
local function bhv_custom_grand_star_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oInteractType = INTERACT_WARP
    o.oIntangibleTimer = 0
    cur_obj_set_home_once()
end

local function bhv_custom_grand_star_loop(o)
    bhv_warp_loop()
    bhv_grand_star_loop()
end

id_bhvGrandStar = hook_behavior(id_bhvGrandStar, OBJ_LIST_LEVEL, true, bhv_custom_grand_star_init, bhv_custom_grand_star_loop)



function get_star_collection_dialog()
    return 0
end


hook_event(HOOK_GET_STAR_COLLECTION_DIALOG, get_star_collection_dialog)
hook_event(HOOK_ON_LEVEL_INIT, wrong_warp)
hook_event(HOOK_MARIO_UPDATE, true_ending_reward)